#include <stdio.h>
#include <stdlib.h>
#include "terrain.h"
#include "structures.h"
#include "personnage.h"
#include "deplacements.h"

/*!
* \file case.c
* \brief Fichier contenant le code des fonctions liees aux cases
*/

void init_case(Case * c,int x,int y, Terrain *t){
    c->coord_x=x;
    c->coord_y=y;
    c->terrain=t;
    c->occupee=faux;
    printf("size of Case : %d\nadresse x : %d\nadresse y : %d\nadresse terrain : %d \nadresse occupee : %d\n",sizeof(*c),&c->coord_x, &c->coord_y,&c->terrain,&c->occupee);
}

int get_x(Case *c){
    return c->coord_x;
}

int get_y(Case *c){
    return c->coord_y;
}

boolean est_occupee(Case *c){
    return c->occupee;
}

boolean case_franchissable(Case *c){
    return terrain_franchissable(c->terrain);
}

void marquer_occupee(Case *c){
    c->occupee=vrai;
}

void marquer_libre(Case *c){
    c->occupee=faux;
}

Terrain* get_terrain(Case *c){
    if (c->terrain==NULL){
        return NULL;
    }
    return c->terrain;
}

  /*!
 * \fn Carte * nouvelleCarte()
 * \brief La fonction alloue l'espace en memoire pour une structure Carte et renvoye un pointeur vers la structure creee
 *
 * \return Le pointeur vers la Carte creee.
 */
Carte * nouvelleCarte(){
    Carte * c = malloc(sizeof(Carte));
    return c;
}

  /*!
 * \fn void deleteCarte(Carte * c)
 * \brief libere l'espace memoire alloue a une Carte
 *
 * \param le pointeur vers la Carte a supprimer.
 */
void deleteCarte(Carte * c){
    free(c);
}

  /*!
 * \fn init_carte(Carte* c,unsigned short int largeur, unsigned short int hauteur)
 * \brief La fonction initialise la position des Case contenues dans la Carte et les definit comme libres.
 *        l'attribut Terrain de la Carte est initialis a NULL, il doit etre change a partir d'une autre fonction.
 *
 * \param Un pointeur vers la Carte a initialiser, des entiers representant la largeur et la hauteur de la carte.
 * \return 0 si la Carte n'a pas ete correctement initialisee (si la taille maximum de la carte est depassee), 1 sinon.
 */
int init_carte(Carte * c){
    int i,j,n;
    n=c;
    for (i=0;i<LARG_MAX_CARTE;i++){
        for (j=0;j<HAUT_MAX_CARTE;j++){
            init_case(n,i,j,NULL);
            printf("Adresse Case : %d, x=%d, y=%d\n\n",n,get_x(n),get_y(n));
            n=n+sizeof(Case);
        }
    }
    return 1;
}
